<#
.SYNOPSIS
    Startet eine Citrix Published App oder Desktop
.NOTES
    Basiert auf Script von A. Stalbold - Sepago GmbH
    Anpassungen durch F.P.Schultze - F&M
#>
 
Param
(
    #Name der Published App oder Desktop
    [Parameter()]
    [string]
    $PublishedApp = 'Desktop'
)
 
$SelfServiceExe = '{0}\Citrix\ICA Client\SelfServicePlugin\SelfService.exe' -f ${env:ProgramFiles(x86)}
$PublishedAppKey = 'HKCU:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\*@@*.{0}' -f $PublishedApp
$LaunchString = $null
 
# Anmeldung Receiver
Start-Process -FilePath $SelfServiceEXE -ArgumentList '-Logon' -Wait
 
# Abrufen der Published Apps (erzeugt Regschlssel)
Start-Process -FilePath $SelfServiceEXE -ArgumentList '-Poll' -Wait
 
# Sobald verfgbar, Launch-Informationen lesen
do
{
    if (Test-Path -Path $PublishedAppKey)
    {
        $LaunchString = (Get-ItemProperty -Path $PublishedAppKey -Name LaunchString).LaunchString
        break
    }
    Start-Sleep -Seconds 1
} while ($true)
 
# Start Published App
Start-Process -FilePath $SelfServiceExe -ArgumentList $LaunchString